function util_get_time(){
    return new Date().getTime() ; // 1622427445085
}

function util_check_expire(expire_date=''){
    if(expire_date==''){
        return true;
    }
    expire_date = expire_date.replace('T00:00:00.000Z','');
    let now_date = new Date();
    expire_date_list = expire_date.split('-');
    expire_date_f = new Date(expire_date_list[0], (expire_date_list[1]-1), expire_date_list[2]);
    if (now_date > expire_date_f) {
        return true;
    }
    return false;
}

function utl_get_website(url) {
    url = unescape(url);
    var theRequest = new Object();
    if (url.indexOf("?") != -1) {
        var str = url.substr(1);
        strs = str.split("&");
        for (var i = 0; i < strs.length; i++) {
            theRequest[strs[i].split("=")[0]] = unescape(strs[i].split("=")[1]);
        }
    }
    if(theRequest.hasOwnProperty('url')){
        return theRequest['url'];
    }
    return '';
}

function shangjia_items_update(shangjia_items = []){
    if(localStorage.getItem("shangjia_items") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
    }
    shangjia_items_list = JSON.parse(localStorage['shangjia_items']);
    //
    for(let i=0;i<shangjia_items.length;i++){
        let is_exists = false;
        for(let j=0;j<shangjia_items_list.length;j++){
            if(shangjia_items_list[j]['Domain'] == shangjia_items[i]['Domain']){
                is_exists = true;
                break;
            }
        }
        if(is_exists == false){
            shangjia_items_list.push(shangjia_items[i]);
        }
    }
    //
     localStorage['shangjia_items'] = JSON.stringify(shangjia_items_list);
    //
}

function shangjia_items_get(){
    if(localStorage.getItem("shangjia_items") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
    }
    shangjia_items_list = JSON.parse(localStorage['shangjia_items']);
    //
    return shangjia_items_list;
}

function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}

//返回html
async function fetch_request_common(url){
     var return_html = '';
     let options = {
         //mode:'no-cors',
         mode:'cors',
         //"Access-Control-Allow-Origin":"*",
         //"Access-Control-Allow-Methods": "HEAD, GET, POST, PUT, PATCH, DELETE",
         //"Access-Control-Allow-Headers": "Origin, Content-Type, X-Auth-Token",
         method: 'get',
         headers: {
             //'Content-Type':'application/json;charset=utf-8',
             "Content-Type": "text/plain;charset=UTF-8"
         },
         referrer: url,
         //referrerPolicy: "no-referrer-when-downgrade",
         // body: JSON.stringify(res)
     }
     // Fake api for making post requests
    //console.log('fetch_request url:'+url);
    await fetch(url,options)
        .then(res => res.text())
        .then(d => {
            //403错误也是直接到这里了
            console.log('post response:');
            //console.log(d);
            return_html = d;
        }).catch(function (){
            console.log('fetch_request error url:'+url);
            return_html = '';
        })
    return return_html;
}

$(document).ready(function () {
    let current_url = window.location.href;
    if(current_url.indexOf('.com.vn') != -1){
        //越南
         extract_comvn_shangjias();
    }else if(current_url.indexOf('.com.br') != -1){
        //巴西
         extract_combr_shangjias();
    }else if(current_url.indexOf('.co.th') != -1){
        //泰国
         extract_coth_shangjias();
    }else{
        //美国
        extract_shangjias();
    }
});

function extract_shangjias(){
    var shangjia_infos = [];
    $('.search-results .result').each(function (){
        //
        var shangjia_name = $(this).find('.business-name').text();
        var shangjia_categories_str = '';
        $(this).find('.categories a').each(function (){
            shangjia_categories_str+=$(this).text()+',';
        });
        shangjia_categories_str = shangjia_categories_str.substring(0, shangjia_categories_str.length-1);
        //
        var shangjia_website = '';
        var shangjia_domain = '';
        shangjia_website = $(this).find('a.track-visit-website').attr('href');
        if(shangjia_website){
           shangjia_domain = shangjia_website.replace('https://', '')
                        .replace('http://','')
                        .replace('www.','');
           if(shangjia_domain){
               shangjia_domain = shangjia_domain.split("/")[0];
           }
        }
        //
        var shangjia_year = $(this).find('.years-in-business .number').text();
        //
        var shangjia_info = $(this).find('.snippet .body').text();
        var shangjia_phone = $(this).find('.phone').text();
        var shangjia_address = $(this).find('.adr').text();
        //
        if(shangjia_website){
            var shangjia_info = {
                'Name': shangjia_name,
                'Website': shangjia_website,
                'Domain': shangjia_domain,
                'Phone': shangjia_phone,
                'Address': shangjia_address,
                'Categories': shangjia_categories_str,
                'Info':shangjia_info,
                'YEARS IN BUSINESS':shangjia_year
            };
            shangjia_infos.push(shangjia_info);
        }
        //
    });
    shangjia_items_update(shangjia_infos);
}

function extract_comvn_shangjias(){
    var shangjia_infos = [];
    $('.div_listings .shadow').each(function (){
        //
        var shangjia_name = $(this).find('h2.p-1').text();
        console.log('shangjia_name:'+shangjia_name);
        var shangjia_catalog = $(this).find('.category_style_market_pc').text();
        //
        var shangjia_info = $(this).children('div.p-0').eq(-2).text();
        if(shangjia_info.indexOf('CATEGORY') != -1){
            shangjia_info = $(this).find('.listing_address_nologo').children('div.p-2').eq(0).text();
        }
        var shangjia_website = '';
        var shangjia_email = '';
        //
        $(this).find('.email_website a').each(function (){
            let _a_href = $(this).attr('href');
            if(_a_href.indexOf('mailto') != -1){
                shangjia_email = _a_href.replace('mailto:', '');
            }else{
                shangjia_website = _a_href;
            }
        });
        //
        var shangjia_phone = $(this).find('.listing_address_nologo').children('div.p-2').eq(1).text();
        if(shangjia_phone.length==0){
            shangjia_phone = $(this).find('.logo_lisitng_address').children('.p-2').eq(1).text();
        }
        if(1){
            let shangjia_domain = '';
            if(shangjia_website){
               shangjia_domain = shangjia_website.replace('https://', '')
                            .replace('http://','')
                            .replace('www.','');
               if(shangjia_domain){
                   shangjia_domain = shangjia_domain.split("/")[0];
               }
            }
            let shangjia_num = $(this).find('.sothutu_div_inner').text();
            if(shangjia_domain==''){
                shangjia_domain = 'none'+util_get_time();
            }
            var shangjia_info = {
                'Domain': shangjia_num,
                'Name': shangjia_name,
                'Website': shangjia_website,
                'Email': shangjia_email,
                'Phone': shangjia_phone,
                'Categories': shangjia_catalog,
                'Info':shangjia_info
            };
            shangjia_infos.push(shangjia_info);
        }
        //
    });
    shangjia_items_update(shangjia_infos);
}

function extract_combr_shangjias(){
    //console.log('extract_combr_shangjias');
    let _tiqu_i = 1;
    $('#esearch_results .mdc-shape-container').each(function () {
        //
        var shangjia_items = [];
        if(localStorage.getItem("shangjia_items") == null){
            localStorage['shangjia_items'] = JSON.stringify([]);
        }
        shangjia_items = JSON.parse(localStorage['shangjia_items']);
        //
        var shangjia_name = $(this).find('h2.card__title a').text();
        if(shangjia_name.length > 0){
            //console.log('shangjia_name:'+shangjia_name);
            var shangjia_address = $(this).find('address').text();
            var shangjia_detail_url = $(this).find('h2.card__title a').attr('href');
            //
            let is_exists = false;
            for(j=0;j<shangjia_items.length;j++){
                if(shangjia_items[j]['Domain'] == shangjia_detail_url){
                    is_exists = true;
                    break;
                }
            }
            let _shangjia_process = '正在提取当前页第'+_tiqu_i+'商家...';
             $('.results-pagination').append(_shangjia_process);
            if(is_exists == false) {
                let shangjia_website = '';
                let shangjia_tel = '';
                let _res_html = ajax_get(shangjia_detail_url);
                if (_res_html && _res_html != 'error') {
                    let _res_jquery = $(_res_html);
                    shangjia_website = _res_jquery.find('.company-card-info .urls a').attr('href');
                    _res_jquery.find('.company-card-info a').each(function (){
                        let a_href = $(this).attr('href');
                        if(a_href.indexOf('tel') != -1){
                            shangjia_tel = a_href.replace('tel:', '');
                        }
                    });
                    //
                    var shangjia_info = {
                        'Domain': shangjia_detail_url,
                        'Name': shangjia_name,
                        'Website': shangjia_website,
                        'Phone': 'tel:'+shangjia_tel,
                        'Address': shangjia_address
                    };
                    shangjia_items.push(shangjia_info);
                    shangjia_items_update(shangjia_items);
                    $('.results-pagination').append('已提取完成<br />');
                }else{
                    $('.results-pagination').append('未采集到，可以尝试稍后刷新下当前页(或者更换代理再刷新)，会重新采集<br />');
                }
            }else{
                $('.results-pagination').append('已提取完成<br />');
            }
            _tiqu_i++;
        }
        //
    });
}

function extract_coth_shangjias(){
    /*
    https://www.xn--72cab5ea0awjx5d5b0c7il6c5dj.com/contactus
    https://www.yellowpages.co.th/en/profile/Taisia-LED-Thailand-Co-Ltd-93wWsXVR8
    https://srithongchareon.yellowpages.co.th/contactus
    https://www.rayonghiled.com/ 无contactus 但是也可以直接加载访问
     */
    let _tiqu_i = 1;
    $('.pager-nav').append('<br />');
    $('.search-list-section .yp-search-listing').each(function () {
        //
        var shangjia_items = [];
        if(localStorage.getItem("shangjia_items") == null){
            localStorage['shangjia_items'] = JSON.stringify([]);
        }
        shangjia_items = JSON.parse(localStorage['shangjia_items']);
        //
        var shangjia_name = $(this).find('h3 a').text();
        if(shangjia_name.length > 0){
            //console.log('shangjia_name:'+shangjia_name);
            var shangjia_yellopages_url = $(this).find('h3 a').attr('href');
            //
            let is_exists = false;
            for(j=0;j<shangjia_items.length;j++){
                if(shangjia_items[j]['shangjia_yellopages_url'] == shangjia_yellopages_url){
                    is_exists = true;
                    break;
                }
            }
            let _shangjia_process = '正在提取当前页第'+_tiqu_i+'商家...';
            //$('.pager-nav').append(_shangjia_process);
            if(is_exists == false) {
                console.log('extract_coth_shangjias a1:'+shangjia_yellopages_url);
                let shangjia_website = '';
                let shangjia_tel = '';
                let shangjia_category = '';
                let shangjia_address = '';
                let shangjia_email = '';
                let shangjia_line = '';
                //
                if(shangjia_yellopages_url.indexOf('profile') == -1){
                    shangjia_yellopages_url += '/contactus';
                    var message = {
                        action: 'yellowpages_co_tg_get_shangjia_data',
                        req_url: shangjia_yellopages_url
                    };
                    send_message_to_background_yellowpages_co_tg_get_shangjia_data(message);
                }else{
                    let _res_html = ajax_get(shangjia_yellopages_url);
                    if (_res_html && _res_html != 'error') {
                        //
                        let _res_jquery = $(_res_html);
                        //

                        shangjia_category = _res_jquery.find('.page-profile-content .profile-category a').text();
                        _res_jquery.find('.page-profile-content .profile-contact').find('a').each(
                                function (){
                                    let a_href = $(this).attr('href');
                                    if(a_href.indexOf('tel') != -1){
                                        shangjia_tel = a_href.replace('tel:', '');
                                    }
                                }
                            );
                        //
                        shangjia_address = _res_jquery.find('.page-profile-content .profile-contact')
                                .find('.profile-contact-details').eq(0).find('.no-gutter').text();
                        //
                        shangjia_email = _res_jquery.find('.profile-social-share').find('a.btn-email').attr('data-to');
                        //
                        var shangjia_info = {
                            'Domain':shangjia_yellopages_url,
                            'Yellowpages Url': shangjia_yellopages_url,
                            'Name': shangjia_name,
                            'Website': shangjia_website,
                            'Phone': shangjia_tel,
                            'Email':shangjia_email,
                            'Line':shangjia_line,
                            'Category': shangjia_category,
                            'Address': shangjia_address
                        };
                        //console.log('shangjia_info');
                        //console.log(shangjia_info);
                        shangjia_items.push(shangjia_info);
                        shangjia_items_update(shangjia_items);
                        $('.pager-nav').append(shangjia_name+'已提取完成<br />');
                    }else{
                        $('.pager-nav').append(shangjia_yellopages_url+'未采集到，可以尝试稍后刷新下当前页(或者更换代理再刷新)，会重新采集<br />');
                    }
                }
                //
            }else{
                $('.pager-nav').append(shangjia_name+'已提取完成<br />');
            }
            _tiqu_i++;
        }
        //
    });
}

var navigation_url = '';
function perf_observer(list, obserer){
    //console.log('aa');
    //console.log(getNetworkRequests(list.getEntriesByType('resource')));
    performanceResourceList = list.getEntriesByType('resource');
    //console.log(performanceResourceList);
    for(i = 0; i<performanceResourceList.length; i++){
        performanceResourceItem = performanceResourceList[i];
        //console.log('abababa');
        //console.log(performanceResourceItem);
        if(performanceResourceItem['initiatorType'] == 'fetch'){
            if(performanceResourceItem['name'].indexOf('search/snippet')>-1){
                //console.log(performanceResourceItem['name']);
                console.log('bbbb'+performanceResourceItem['name']);
                //
                var shangjia_infos_result = fetch_request(performanceResourceItem['name']);
                shangjia_infos_result.then((result) => {
                    //console.log('afafaaf');
                    //console.log(result);
                   var shangjia_infos_list = [];
                   var shangjia_infos_ = result;
                   for(let f=0;f<shangjia_infos_.length;f++){
                       shangjia_infos_list.push(shangjia_infos_[f]);
                   }
                   shangjia_items_update(shangjia_infos_list);
                   //
                })
            }
        }
    }
    //////
    performanceNavigationList = list.getEntriesByType('navigation');
    for(i = 0; i<performanceNavigationList.length; i++) {
        performanceNavigationItem = performanceNavigationList[i];
        if (performanceNavigationItem['initiatorType'] == 'navigation') {
            navigation_url = performanceNavigationItem['name']
        }
    }
}
var observer_ = new PerformanceObserver(perf_observer);
//observer_.observe({entryTypes:['resource', 'navigation']});

function extract_get_catalog_products_num(){
    var shangjia_items = shangjia_items_get();
    var maijia_num = 0;
    if(typeof shangjia_items != 'undefined'){
        maijia_num = shangjia_items.length;
    }
    return maijia_num;
}

function xintiao(){
    var shangjia_items = shangjia_items_get();
    var maijia_num = 0;
    if(typeof shangjia_items != 'undefined'){
        maijia_num = shangjia_items.length;
    }
    var message = {
        action: 'update-shangjia-num',
        info: '',
        maijia_num: maijia_num
    };
    send_message_to_popup(message);
}
setInterval(xintiao, 3000);

function getUrlParam(url,name) {
    if(url){
        console.log('url:'+url);
        var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)"); //构造一个含有目标参数的正则表达式对象
        var url_list = url.split('?');
        if(url_list.length>=2){
            var r = url_list[1].match(reg);  //匹配目标参数
            if (r != null) return unescape(r[2]); return ''; //返回参数值
        }
    }
    return '';
}

async function fetch_request(url){
     var shangjia_infos = [];
            let options = {
                method: 'get',
                headers: {
                    'Content-Type':'application/json;charset=utf-8'
                },
                // body: JSON.stringify(res)
            }
            // Fake api for making post requests
            //console.log('fetch_request url:'+url);
            await fetch(url,options).then(res =>
                            res.json()).then(d => {
                                //console.log('fetch_request response:');
                                //console.log(d);
                                //
                                //console.log(d);
                                var data_d_val = d['searchPageProps']['mainContentComponentsListProps'];
                                //console.log(data_d_val);

                                var shangjia_items = data_d_val;
                                for (j = 1; j < shangjia_items.length; j++) {
                                    //
                                    var shangjia_item = shangjia_items[j];
                                    //
                                    if(shangjia_item.hasOwnProperty('searchResultBusiness')){
                                        var searchResultBusiness = shangjia_item['searchResultBusiness'];
                                        //
                                        var shangjia_name = searchResultBusiness['name'];
                                        var shangjia_website = '';
                                        var shangjia_domain = '';
                                        if(searchResultBusiness.hasOwnProperty('website')){
                                            var website_dict = searchResultBusiness['website'];
                                            if(website_dict && website_dict.hasOwnProperty('href')){
                                                var shangjia_website = searchResultBusiness['website']['href'];
                                                shangjia_website = unescape(shangjia_website);
                                                //
                                                if(shangjia_website.indexOf('adredir') > -1){
                                                    let ad_shangjia_website = 'https://www.yelp.com'+shangjia_website;
                                                    shangjia_website = utl_get_website(ad_shangjia_website);
                                                }
                                                //
                                                shangjia_domain = shangjia_website.replace('https://', '')
                                                    .replace('http://','')
                                                    .replace('www.','');
                                            }
                                        }
                                        var shangjia_categories = searchResultBusiness['categories'];
                                        var shangjia_categories_str = '';
                                        if(typeof shangjia_categories != 'undefined'){
                                            for(let l=0;l<shangjia_categories.length;l++){
                                                shangjia_categories_str+=shangjia_categories[l]['title']+',';
                                            }
                                            shangjia_categories_str = shangjia_categories_str.substring(0, shangjia_categories_str.length-1);
                                        }
                                        //
                                        var fulladdress = searchResultBusiness['formattedAddress'];

                                        var shangjia_info = {
                                            'Name': shangjia_name,
                                            'Website': shangjia_website,
                                            'Domain': shangjia_domain,
                                            'Fulladdress': fulladdress,
                                            'Categories': shangjia_categories_str
                                        };
                                        shangjia_infos.push(shangjia_info);
                                    }
                                }
                                //
                            })
    return shangjia_infos;
}

function extract_catalog_products_export_clean_com(){
    //
    var shangjia_infos = [];

    var q_name = $("input[name='search_terms']").val();
    var q_loaction = $('#location').val();
    var expire_data = get_expire();
    var expire_date_dict = expire_data[0];
    var expire_date = expire_date_dict['expire'];
    if(1) {
        //
        shangjia_infos.push({
            'Name': q_name+'_'+q_loaction,
            'Website': navigation_url,
            'Domain': '',
            'Phone': '',
            'Address': '',
            'Categories': '',
            'Info':'',
            'YEARS IN BUSINESS':''
        })
        //
        var shangjia_items_list = shangjia_items_get();
        for(let i=0;i<shangjia_items_list.length;i++){
            shangjia_infos.push(shangjia_items_list[i]);
        }
        //
    }
    //console.log('shangjia_infos2');
    //console.log(shangjia_infos);
     var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': q_name,
         'expire':get_expire()
     }
     //localStorage.removeItem("tbm_map_urls");
     //if(localStorage.getItem("shangjia_items") == null){
      //   localStorage['shangjia_items'] = JSON.stringify([]);
     //}
    //console.log('catalog_products');
    //console.log(catalog_products);
     //console.log('b2');
    return catalog_products;
}

function extract_catalog_products_export_clean_com_vn(){
    //
    var shangjia_infos = [];
    //
    var shangjia_items_list = shangjia_items_get();
    for(let i=0;i<shangjia_items_list.length;i++){
        shangjia_infos.push(shangjia_items_list[i]);
    }
    var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'yellowpages_com_vn_'+util_get_time(),
         'expire':get_expire()
     }
     //localStorage.removeItem("tbm_map_urls");
     //if(localStorage.getItem("shangjia_items") == null){
      //   localStorage['shangjia_items'] = JSON.stringify([]);
     //}
    return catalog_products;
}

function extract_catalog_products_export_clean_com_br(){
    //
    var shangjia_infos = [];
    //
    var shangjia_items_list = shangjia_items_get();
    for(let i=0;i<shangjia_items_list.length;i++){
        shangjia_infos.push(shangjia_items_list[i]);
    }
    //
    console.log('shangjia_infos');
    console.log(shangjia_infos);
    //
    var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'yellowpages_com_br_'+util_get_time(),
         'expire':get_expire()
     }
     //localStorage.removeItem("tbm_map_urls");
     //if(localStorage.getItem("shangjia_items") == null){
      //   localStorage['shangjia_items'] = JSON.stringify([]);
     //}
    return catalog_products;
}

function extract_catalog_products_export_clean_co_th(){
    //
    var shangjia_infos = [];
    //
    var shangjia_items_list = shangjia_items_get();
    for(let i=0;i<shangjia_items_list.length;i++){
        shangjia_infos.push(shangjia_items_list[i]);
    }
    //
    console.log('shangjia_infos');
    console.log(shangjia_infos);
    //
    var catalog_products = {
         'shangjia_infos': shangjia_infos,
         'file_name': 'yellowpages_co_th_'+util_get_time(),
         'expire':get_expire()
     }
     //localStorage.removeItem("tbm_map_urls");
     //if(localStorage.getItem("shangjia_items") == null){
      //   localStorage['shangjia_items'] = JSON.stringify([]);
     //}
    return catalog_products;
}

function extract_catalog_products_export_clean(){
    let current_url = window.location.href;
    if(current_url.indexOf('.com.vn') != -1){
        //越南
         return extract_catalog_products_export_clean_com_vn();
    }else if(current_url.indexOf('.com.br') != -1) {
        //巴西
        return extract_catalog_products_export_clean_com_br();
    }else if(current_url.indexOf('.co.th') != -1){
        //泰国
        return extract_catalog_products_export_clean_co_th();
    }else{
        //美国
        return extract_catalog_products_export_clean_com();
    }
}

function extract_catalog_products_clean(){
    localStorage.removeItem("shangjia_items");

   // if(localStorage.getItem("tbm_map_urls") == null){
        localStorage['shangjia_items'] = JSON.stringify([]);
   // }

    return  {
         'shangjia_items': []
     }
}

function set_expire(date=''){
    console.log('set_expire:'+date);
    var expire = [];
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    localStorage['expire'] = JSON.stringify([{'expire':date}]);

    expire = JSON.parse(localStorage['expire']);
    return expire;
}

function get_expire(){
    if(localStorage.getItem("expire") == null){
        localStorage['expire'] = JSON.stringify([{'expire':''}]);
    }
    expire = JSON.parse(localStorage['expire']);
    return expire;
}

// get popup2content info
chrome.runtime.onMessage.addListener((request, sender, sendResponse) => {
    if(request.action == 'extract_get_catalog_products_num') {
        catalog_products_url = extract_get_catalog_products_num();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract-catalog-products-export-clean'){
        catalog_products_url = extract_catalog_products_export_clean();
        sendResponse(catalog_products_url);
    }else if(request.action == 'extract_catalog_products_clean'){
        catalog_products_url = extract_catalog_products_clean();
        sendResponse(catalog_products_url);
    }else if(request.action == 'set_expire') {
        expire_date = set_expire(request.date);
        sendResponse(expire_date);
    }else if(request.action == 'get_expire'){
        expire_date = get_expire();
        sendResponse(expire_date);
    }
})
//

//send message to pop
function send_message_to_popup(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
    })
}

//send message to background
function send_message_to_background_yellowpages_co_tg_get_shangjia_data(message={}){
    /*
    {
            action: 'extract-catalog-products-export-clean',
            info: ''
        }
     */
    console.log('message');
    console.log(message);
    chrome.runtime.sendMessage(message,(msg)=>{
        console.log('答复',msg)
        //
        let shangjia_data = JSON.parse(msg.state)
        if(shangjia_data['Domain'] == ''){
            $('.pager-nav').append(shangjia_data['Yellowpages Url']+'未采集到，可以尝试稍后刷新下当前页(或者更换代理再刷新)，会重新采集<br />');
        }else{
            var shangjia_items = [];
            if(localStorage.getItem("shangjia_items") == null){
                localStorage['shangjia_items'] = JSON.stringify([]);
            }
            shangjia_items = JSON.parse(localStorage['shangjia_items']);
            shangjia_items.push(shangjia_data);
            shangjia_items_update(shangjia_items);
            $('.pager-nav').append(shangjia_data['Name']+' 已提取完成<br />');
        }
        //
    })
}